 function gnext(v)
	return vway ('дальше', '{Дальше}.', v );
end

function music(v)
	return function()
		set_music(v)
	end
end

main = room {
	pic = 'gfx/map.png',
	nam = '87°52.09 N 147°14.81 E',
	dsc = [[
	14 октября 1961 года. 87°52.09 N 147°14.81 E. Секретная дрейфующая полярная станция СП-2. 150 километров от Северного полюса. До начала полярной ночи — 7 дней.^^
	— Эй, Морозов!!! Пойдем на торосы посмотрим.^
	— Хорошо, сейчас позову Белку и Паровоза...^
	— Карабин я взял!
	]],
	obj = { gnext('i1'), vway('Пропустить', '^^{Пропустить введение}.', 'i11') },
};

belka = obj {
	nam = 'Белка',
	dsc = function(s)
		if here() == toroses then
			return '{Белка} и';
		end
		return 'Возле нас резвятся: {Белка} и'
	end,
	act = function(s)
		if here() == toroses then
			return 'Собаки очень возбуждены...';
		end
		return 'Я подозвал к себе Белку и потрепал ее. Без собак идти на осмотр торосов опасно, они чувствуют медведей, да и веселее как-то...';
	end		
};

rezvy = obj {
	nam = 'Паровоз',
	dsc = function(s)
		if here() == toroses then
			return '{Паровоз} сильно лают. Похоже они нервничают.';
		end
		return '{Паровоз}.';
	end,
	act = function(s)
		if here() == toroses then
			return 'Собаки очень возбуждены...';
		end
		return 'Я подозвал к себе Паровоза и потрепал его за ушами... Собак на станции очень любят. Иногда мне кажется, что полярной ночью мы бы все сошли с ума без наших собак.';
	end		
};

boss_dlg = dlg {
	pic = 'gfx/potapov-back.png',
	nam = 'Разговор с Потаповым',
	dsc = 'Я кричу Потапову в спину...',
	obj = {
	[1] = phr('Про взрыв слышали?',
		'— Нет, а что такое?', [[ pon(2) ]]),
	[2] = _phr('Бобров рассказал... Наверное, в эфире слышал от радистов...', 
		'— Ну?', [[ pon(3) ]]),
	[3] = _phr('В Семипалатинске провели подземный взрыв...', 
		'Потапов ничего не сказал, но мне показалось, что он крякнул.. Потом он повернулся ко мне и спросил: Вот смотри, в космос Гагарин слетал.... Первым... А теперь туда запустят ядерные ракеты, как думаешь?', [[ pon(4, 5, 6) ]]),
	[4] = _phr('Не знаю... Вряд-ли... Космос общий.', 
		'— А я думаю запустят. Потапов отворачивается и мы снова идем...', [[pon(7, 8); poff(5,6); toroses:enable() ]]),
	[5] = _phr('Да! И коммунизм будет везде!', 
		'Потапов скептически смотрит на меня, потом отворачивается и мы снова идем вперед...', [[pon(7, 8); poff(4, 6); toroses:enable() ]]),
	[6] = _phr('Не хочется об этом думать.', 
		'— Тогда давай просто делать свое дело — Потапов отворачивается и мы снова продолжаем наш путь...', [[pon(7, 8); poff(4,5); toroses:enable() ]]),
	[7] = _phr('На Кубе, наверное, хорошо...', 
		'Потапов ничего не ответил. Но мне показалось, что он пожал плечами.', [[ ]]),
	[8] = _phr('Закончить разговор', nil, [[ pon(); back(); return true ]]),
	},
	exit = function(s)
		s:pon(7);
	end
};

boss_a1 = 'Потапов оборачивается. Потом снова смотрит за лед. Я чувствую его напряжение. Наконец, он возвращается.^^ — Идем за ребятами... И еще, нам понадобится трактор...';

boss_dlg2 = dlg {
	nam = 'Разговор с Потаповым',
	pic = function(s)
		if s._find then
			return 'gfx/toroses-find.png';
		end
		return 'gfx/potapov-front.png';
	end,
	dsc = 'Я поворачиваю свое лицо к Потапову.',
	obj = {
	[1] = phr('Что с собаками? Медведь?', 
		'— Не знаю... В любом случае они лают на торосы...', [[ pon (2) ]] ),
	[2] = _phr('Сильное торошение...',
		'— Да... Как бы без льдины не остаться к концу экспедиции...', [[ pon (3, 4) ]]),
	[3] = _phr('Я пойду посмотрю что там... На всякий случай...',
		'— Не надо. Я сам. — Потапов покрепче сжал свой карабин. — Вдруг медведь...', [[ poff(4); pon(5); ]]),
	[4] = _phr('Я про Кубу хотел сказать...',
		'— Потом. Я схожу посмотрю что там...', [[ poff(3); pon(5); ]]),
	[5] = _phr('Хорошо, я подожду...', 
		'Потапов медленно пробирается к глыбам льда. Я вижу как он изучает что-то за кромкой льда, крепко держа свой карабин в руках.', 
		[[ pon(6, 7); boss_dlg2._find = true;]] ),
	[6] = _phr('Что там?!!!', boss_a1, [[ poff(7); pon(8); ]]),
	[7] = _phr('Мне страшно!!! Что происходит?', boss_a1, [[ poff(6); pon(8); ]]),
	[8] = _phr('Трактор? Зачем трактор???', nil, [[ return goto 'i2' ]]),
	}
};

boss = obj {
	nam = 'Потапов',
	dsc = function(s)
		if here() == toroses then
			return 'Рядом со мной стоит {Потапов}.'
		end
		return 'Перед собой я вижу спину {Потапова} — начальника экспедиции.';
	end,
	act = function(s)
		if here() == toroses then
			return goto('boss_dlg2'); --'Да... Как бы нам без льдины не остаться до конца экспедиции.'
		end
		return goto 'boss_dlg';
	end
};

ices = obj {
	nam = 'торосы',
	dsc = 'Я вижу гротескные очертания {торосов}.',
	act = 'Неприятно осознавать, что под ногами всего лишь 3 метра льда, а под ними — километры воды.',
};

toroses = room {
	nam = 'Западные торосы',	
	pic = 'gfx/toroses.png',
	enter = 'Наконец, мы подошли к западным торосам.',
	dsc = 'Мы с Потаповым смотрим на торосы. Льдины здесь принимают почти вертикальное положение.',
	obj = { 'boss', 'belka', 'rezvy', 'ices' },
} : disable();

i1 = room {
	nam = 'Возле станции',
	pic = 'gfx/going.png',
	dsc = [[
	Под ногами скрипел снег, мы шли друг за другом осматривать нашу льдину... Вот уже 5 месяцев она носила станцию на себе, и в последнее время начала капризничать. Хорошо, если до конца экспедиции она останется цела...
	]],
	obj = { 'boss', 'belka', 'rezvy' },
	way = { 'toroses' },
};

i2 = room {
	nam = 'Западные торосы',
	pic = 'gfx/potapov-front.png',
	forcedsc = true, 
	dsc = '— Там что-то странное... Очень странное... — Только сейчас я заметил, что начинается пурга.',
	obj = { gnext('i3') },
};

knocking = obj {
	_num = 0;
	nam = 'стук в дверь',
	life = function(s)
		s._num = s._num + 1;
		if s._num > 1 then
			lifeoff(s);
			return [[ Внезапно я услышал стук в дверь. — Морозов! Идем есть! Кузьмич уже нервничает!... Я узнал голос аэролога Шилова.
	Кузьмич был хорошим поваром, и оставался им в любых ситуациях... ]], true;
		end
	end,
};

body = obj {
	nam = 'нечто',
	dsc = function(s)
		if not s._opened then
			return 'На полу лежит брезентовый {мешок}.';
		end
		if not s._seen then
			return 'На полу лежит {нечто}.'
		end
		if here() == snowarea then
			return 'В снегу лежит {чужой}.'
		end
		return 'На полу лежит {чужой}.'
	end,
	act = function(s)
		if not s._opened then
			s._opened = true
			return 'Я развязал мешок и не без содрогания освободил то, что в нем находилось...';
		end
		if not s._seen then
			s._seen = true
			return [[ Я смотрю и понимаю, что это — НЕ ЧЕЛОВЕК. Страшное, злое лицо, если это можно назвать лицом... Почти черная, темно-зеленая кожа. Роговые наросты... Меня начинает мутить...^^
И все-таки я пытаюсь изучить ЭТО. Судя по-всему оно мертво... Растаявший лед капает на пол лаборатории. А я все не свожу глаз с зловещих очертаний... Нужно 
что-то понять, за что-то зацепиться...]]
		end
		return 'Что бы это ни было — оно мне не нравится...' 
	end,
};

i3 = room {
	nam = 'Два часа спустя',
	pic = 'gfx/intolab.png',
	enter = music('snd/stein.s3m'),
	dsc = [[ — Тащите в лабораторию! Отзовите собак! Морозов! Морозов!! Доктор!!! А, ты здесь — готовь лабораторию...^^
Не смотря на все попытки отогнать лающих собак, они сопровождали странный груз — громоздкий брезентовый мешок — до самой лаборатории.
Затащив мешок в лабораторию, Шубин и Медведев с облегчением ослабили веревки, и мешок с глухим стуком упал на грязный пол... ^^
— Все док, он в вашем полном распоряжении — пробует шутить Медведев. Но никто не смеется...^^
Через несколько секунд я остаюсь один в лаборатории...]],
	exit = function(s)
		ways 'labhall':add(vroom('Выйти из лаборатории','i4'));
		objs 'labhall':add('body');
	end,
	obj = { gnext('labhall') },
};

tests = obj {
	nam = 'анализы',
	inv = 'Это анализы крови чужого.',
};

i4 = room {
	nam = 'В кают-компании',
	pic = 'gfx/livhall-full.png',
	house_type = true,
	enter = function(s)
		if labhall._locked ~= NONE then
			return 'Дверь закрыта...', false
		end
		if not have 'tests' then
			return 'Я должен изучить ЭТО...', false;
		end
		if knocking._num ~= 2 then
			return 'Гм... Может, провести вскрытие?..', false
		end
		ways 'labhall':del('Выйти из лаборатории');
	end,
	dsc = [[
	Мы сидим в кают-компании, по совместительству столовой, составленной из двух домиков ПДКО.
	За столом собрался весь экипаж станции. Когда обед подходит к концу, Потапов начинает ожидаемый разговор...^^
	— Итак, товарищи, многие из нас видели это на западных торосах... Для тех, кто не участвовал... — Потапов немного помолчал. — В операции, я повторю то, что мы знаем... 
	— Сегодня, мы с доктором, осматривая торосы, обнаружили странный... объект. Объект вмерз в лед, но не полностью...^^
	— В общем, мы попытались его освободить... Сначала мы освободили... люк. — Да, там был люк. Потапов посмотрел на 
	удивленные лица техника Климова и Кузьмича. — И вытащили... гм... существо. Тварь. Не знаю — о нем нам расскажет доктор. Позже.^^
	— Потом мы попытались вытащить объект с помощью трактора, но как назло, между нами прошла трещина... Объект теперь
	находится в свободном плавании... Трактор удалось спасти. Вот и все, что мы знаем. Доктор?]],
	obj = { gnext('i5') },
}

i5 = dlg {
	nam = 'В кают-компании',
	pic = 'gfx/morozov.png',
	house_type = true,
	dsc = 'Я встал из-за стола, чувствуя сильное напряжение. На меня смотрели десять пар глаз.',
	obj = {
	[1] = phr('Мне нечего сказать, кроме того, что анализы у него в норме. По-человеческим меркам.',
		   ' — Но оно же мертво? — молодой магнитолог Никитин не скрывает своего страха.', 
		 [[pon(3)]]),
	[2] = phr('Я в панике, это нечто чужое. Не знаю, откуда. Ничего не знаю!!!',
		   'Я вижу как экипаж молчаливо смотрит на меня.'),
	[3] = _phr('Судя по всему — мертво. Но кровь — в порядке. Я пока не проводил вскрытия.',
		   [[ — Вы уверены — Потапов перешел на "Вы", подчеркивая официальность разговора. — Вы уверены, что
		   вам больше нечего сказать, доктор?]], [[ pon(4); pon(5) ]]),
	[4] = _phr('Увы, нечего. Обстоятельства говорят о том, что оно мертво очень давно, но оно хорошо сохранилось.',
		   'Хорошо, доктор.. Садитесь пожалуйста.', [[ return goto 'i6' ]]),
	[5] = _phr('Ничего особенного... Кроме того, что его кровь очень похожа на нашу.',
		   'Хорошо, доктор.. Проведите вскрытие как можно скорее. Садитесь.', [[ return goto 'i6' ]]),
	}
}

meshok = obj {
	nam = 'мешок',
	dsc = 'На полу лежит пустой брезентовый {мешок}.',
	act = function(s)
		if not s._takable then
			return 'Мешок пуст!!! Он ПУСТ!!!'
		end
		return 'Взять мешок? Но он очень большой и тяжелый. К тому же он навевает на меня плохие воспоминания.'
	end
};

function install_pechki()
	put (new_pech(false), 'rhall');
	put (new_pech(false), 'shall');
	put (new_pech(false), 'house1');
	put (new_pech(false), 'house2');
	put (new_pech(false), 'house3');
	put (new_pech(false), 'house4');
	put (new_pech(false), 'house5');
	put (new_pech(false), 'labhall');
end

i6 = room {
	nam = 'В кают-компании',
	pic = 'gfx/livhall-full.png',
	house_type = true,
	enter = 'Я сажусь на стул. В столовой — тишина.',
	dsc = [[
	— Итак. Версий только две... Первая — эта штука прилетела к нам из космоса и вторая...^^
	— Американцы? — Кузьмич улыбается своей широкой улыбкой, такой неуместной и такой нужной сейчас.^^
	— Хм... Ладно, у нас одна версия. Но от этого не легче. Пока доктор не получит новых сведений на
	базу информацию  не передавать, слышишь, Бобров? Что-то мне подсказывает, что они нас неправильно поймут...
	Все возвращаемся к работе. Морозов в лаборатории. Если что — я у себя...
	]],
	obj = { gnext('labhall') },
	exit = function(s)
		human0._human = false;
		aliens.list:add 'human0';
		objs 'labhall':del 'body';
		objs 'labhall':add 'meshok';
		ways 'labhall':add (vroom('Выйти из лаборатории', 'i7'));
		human0._do = STAND;
		put ('body', 'house1');
		put ('human0', 'house1');
		put ('blood_flood', 'house1');
		put ('human1','rhall');
		put ('human2','house3'); 
		put ('human3','meteo'); 
		put ('human4','meteo'); 
		put ('human5','dhall'); 
		put ('human6','dhall'); 
		put ('human7','kambuz'); 
		put ('human8','livhall'); 
		put ('human9','livhall');
		rhall._locked = NONE
		dhall._locked = NONE
		livhall._locked = NONE
		human1._do = OTHER
		human2._do = OTHER
		human3._do = OTHER
		human4._do = OTHER
		human5._do = OTHER
		human6._do = OTHER
		human7._do = OTHER
		human8._do = OTHER
		human9._do = OTHER
		install_pechki();
		lifeon('intro_end');
		game._intro = true;
	end,
}

intro_end = obj {
	nam = 'checker',
	life = function(s)
		if here() == house_entrance and s._trigg then
			lifeoff(s);
			ACTION_TEXT = nil;
			return goto('i8'), true;
		end
	end
};

i7 = room {
	nam = 'Метеоплощадка',
	pic = 'gfx/meteo.png',
	forcedsc = true,
	dsc = [[ Я бросился к столу и достал свой револьвер. Затем выбежал из лаборатории и осмотрелся.
		В лицо мне ударил холодный ветер. Чужого нигде не было видно. ]],
	enter = function(s)
		take 'revolver';
		ways 'labhall':del ('Выйти из лаборатории');
	end,
	obj = { gnext('meteo') },
}

i8 = room {
	nam = 'Лаборатория',
	pic = labhall.pic,
	house_type = true,
	dsc = [[ Мы притащили его в лабораторию. Собаки станции провожали нас громким лаем. Затем, Потапов ушел и 
	я услышал удаляющийся лай собак. Я принялся за работу...]],
	obj = { gnext('i9') },
}

i9 = room {
	nam = '15 октября. Кают-компания.',
	pic = 'gfx/livhall-full2.png',
	house_type = true,
	dsc = [[
		...^
		Первым тишину нарушил Кузьмич.^
		— Значит, ты видел как Потапов ломает передатчик?^
		— Да.^
		— И ты убил его?^
		— Да.^
		— Он же был твоим другом!!! — механик Штахель почти выкрикнул эти слова.^ 
		— Мой друг умер. Погиб. Это был не человек... — я посмотрел на Штахеля. Кажется, он увидел что-то в моих глазах и замолчал.^
		— А что ты делал в радиорубке? — это был Бобров.^
		— После сегодняшней ночи, когда у нас пропали собаки и оружие, я решил, что всего этого достаточного для того... — мне казалось, что я слышал свой голос со стороны... ^
		— Чтобы не подчиниться приказу начальника станции? — перебил меня Бобров.^
		— Да.^
		— И ты говоришь, что Потапов был чужим? И что он лежит сейчас в лаборатории, мертвый, и ты его там исследуешь? — я с трудом понимал, кто меня спрашивает.^
		— Да. Пытаюсь.^
		— Это все какой-то бред!^
		— Хорошо, откуда ты взял оружие? — другой голос.^
		— Револьвер... У меня есть револьвер...^
		— Револьвер?^ 
		— Да. Подарок. От отца.^
		— Хорошо, надо решать что нам с этим всем делать...^
		— Если вы мне не поверите, боюсь, у нас нет будущего — я слышу свой собственный голос, такой чужой...^
		...
	]],
	obj = { gnext('i10') },
};
i10 = room {
	nam = '16 октября. Радиорубка. 5:17 утра.',
	house_type = true,
	dsc = [[
		Я сижу в радиорубке. Некоторое время я рассеянно разглядываю полностью разрушенный СВ передатчик,
		но потом заставляю себя взять в руки микрофон местной радиостанции.^^
		— Станция. Внимание. Говорит Морозов. Сообщение чрезвычайной важности... Поборов минутный приступ слабости, я продолжил.^^
		— У меня есть что рассказать вам про то, с чем мы столкнулись... Я не знаю как именно, но эта тварь
		заразила Потапова, причем таким образом, что его кровь изменилась на молекулярном уровне, при этом... При этом она осталась нормальной... Я обнаружил разницу между образцами крови взятыми до и после заражения.^^
		— Это значит, что тварь заразила Потапова, и возможно, кого-то еще... Механизм заражения мне не известен,
		но я уверен, что тварь заразила Потапова прямо у него в домике, моментально, пока я бежал за ней из
		лаборатории...  А потом, чтобы сбить нас со следа, вторая тварь убила первую. Значит, она умна.^^
		— Зараженный человек продолжает выглядеть как человек, и, вероятно, кроме возможности заражать 
		новую жертву, внешне он ничем не отличается от того, кем был до заражения... 
		По крайней мере, до тех пор, пока не закончится изменение крови.^^
		— Хорошая новость, я могу по двум анализам крови определить факт заражения...^^
		— Плохая новость — из-за нехватки оборудования, за сутки я могу проверить только одного из нас.^^
		— Началась полярная ночь, у нас нет СВ-передатчика, и каждый из нас может быть врагом.^^
		— У нас нет оружия, но у меня есть мой револьвер, и я буду делать свою работу не зависимо от того,
		верите вы мне или нет...^^
		— Оставайтесь в своих домиках, следите друг за другом. Я думаю, что если вы окажетесь один на один с тварью,
		у вас нет шансов. Но если тварь одна, то она будет осторожна и хитра. Не доверяйте никому. На станции
		объявляется....
	]],
	obj = { gnext('i11') },
}

function prepare_game()
	human0._do = DEAD;
	put('human0', 'snowarea');
	put('body', 'snowarea');
	body._opened = true;
	body._seen = true;

	aliens.list:del('human0');
	
	remove ('body', 'house1');
	remove ('human0', 'house1');
	remove ('human1','rhall');
	remove ('human2','house3'); 
	remove ('human3','meteo'); 
	remove ('human4','meteo'); 
	remove ('human5','dhall'); 
	remove ('human6','dhall'); 
	remove ('human7','kambuz'); 
	remove ('human8','livhall'); 
	remove ('human9','livhall');

	house1._locked = NONE
	house2._locked = NONE
	house3._locked = NONE
	house4._locked = NONE
	house5._locked = NONE
	rhall._locked = NONE
	dhall._locked = OUTSIDE
	livhall._locked = NONE;
	labhall._locked = NONE;
	
	revolver._armed = 4
	inv():del('tests');
	inv():add('status',1);
	inv():add('sleep',2);
	inv():add('sep',3);
	inv():add('revolver');
	putf('differ', 'medtable');
	meshok._takable = true;
--	remove('meshok', 'labhall');
	people_put();
	bear:putin();
	if not game._intro then	
		install_pechki();
	end
	objs 'labhall':add 'meshok';
	putto ('nb', 'livhall', 2);
	light_pech();
end

i11 = room {
	nam = "INSTEAD '2009-2010",
	pic = 'gfx/title.gif',
	enter = function(s)
		me():disable_all();
		set_music('snd/intro.mod');
	end,
	dsc = function(s)
--		pn (txtc('КАРАНТИН'));		
--		pn ();
		pn (txtc("По мотивам рассказа Джона В. Кэмпбелла «Кто идёт?»."))
	end,
	obj = { gnext('snowarea') },
	exit = function(s)
		me():enable_all();
		prepare_game();
	end,
}

-- inv():add('status');
-- inv():add('sleep');
-- inv():add('sep');
-- inv():add('revolver');

